function Ajax() {
    this.xhr = null;
    if (window.ActiveXObject) {
        this.xhr = new ActiveXObject("Microsoft.XMLHTTP");
    } else if (window.XMLHttpRequest) {
        this.xhr = new XMLHttpRequest();
    }
}

Ajax.prototype.get = function (json) {
    json.type = 'GET';
    this.send(json);
}

Ajax.prototype.post = function (json) {
    json.type = 'POST';
    this.send(json);
};

Ajax.prototype.jsonp = function (json) {
    const tag = document.createElement('script');
    document.body.appendChild(tag);
    const random = parseInt(Math.random() * 1000000);
    json.url += ( '?' + this.formatData(json.data) + '&cb=yingview' + random);
    tag.src = json.url;
    window['yingview' + random] = (data) => {
        json.success && json.success(data);
        delete window['yingview' + random];
        document.body.removeChild(tag);
    }
};

Ajax.prototype.send = function (json) {
    this.xhr.responseType || (this.xhr.responseType = json.dataType || 'json');
    let sendData = null;
    if (json.type.toUpperCase() === 'POST') {
        sendData = this.formatData(json.data);
        this.xhr.open(json.type, json.url, json.async || true);
        this.xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    } else  {
        json.url += ( '?' + this.formatData(json.data));
        this.xhr.open(json.type, json.url, json.async || true);
    }
    this.xhr.send(sendData);
    this.xhr.onreadystatechange = function () {
        if (this.xhr.readyState == 4) {
            if (this.xhr.status == 200) {
                json.success && json.success(this.xhr.response)
            } else {
                json.error && json.error()
            }
        }
    }.bind(this)
}

Ajax.prototype.formatData = function (data) {
    if (typeof data === 'object') {
        var convertResult = "";
        for (var c in data) {
            convertResult += c + "=" + data[c] + "&";
        }
        convertResult = convertResult.substring(0, convertResult.length - 1)
        return convertResult;
    }
    return data
}

export default new Ajax();