import React, { Component } from 'react';
import { addClass, isValue, isNumber, isTel, isEmail } from '../Utils';

class Button extends Component {
  render() {
    const { className, style, text, type } = this.props;
    const event = {};
    for(const ev in this.props) {
      if (ev.indexOf('on') !== -1) {
        event[ev] = this.props[ev];
      }
    }
    return (
      <div className={addClass('button-wrap')}>
        <div
          {...event}
          className={`${className} ${type} button`}
          style={style}
        >
          {text}
        </div>
      </div>
    )
  }
}

Button.propTypes = {
  text: React.PropTypes.string,
  type: React.PropTypes.string,
  className: React.PropTypes.string,
  style: React.PropTypes.object,
  onChange: React.PropTypes.func,
  onblur: React.PropTypes.func,
  onFocus: React.PropTypes.func,
  onClick: React.PropTypes.func,
};
Button.defaultProps = {
  text: '确    定',
  type: 'normal',
  className: '',
  style: {},
  onChange: () => { },
  onblur: () => { },
  onFocus: () => { },
  onClick: () => { },
};
export default Button;