/**
 * 多选级联组件
 * @author 徐志飞
 */

import React, { Component } from 'react';
// import { Button, Fetch, Constant } from '@ali/cg-react';
import Button from '../Button'
import CheckBoxItem from '../Checkbox/CheckBoxItem';

require('./style.less');

// const { CMALL_SERVICE_PREFIX } = Constant;

Array.prototype.contain = function (val) { // 扩展数组
  for (let i = 0; i < this.length; i += 1) {
    if (this[i] == val) {
      return true;
    }
  }
  return false;
};

class CascadeMultiSelect extends Component {
  constructor(props) {
    super(props);
    this.state = {
      arrow: 'kuma-cascader-arrow',
      reflush: 1,
      listIdx: 1000,
      show: false,
      valueString: ''
    };
    if (!props.options.length) {
      // Fetch.set({ getCategoryTree: props.url });
    }
    this.checkedValue = [];
    this.checkedId = [];
    this.container = [];
    for (let i = 0; i < props.cascadeSize; i += 1) {
      this.container[i] = [];
    }
  }
  componentDidMount() {
    document.addEventListener('click', () => {
      this.setState({ arrow: 'kuma-cascader-arrow', show: false });
    });
    this.queryData();
  }

  preventDefault(e) {
    e.nativeEvent.stopImmediatePropagation();
    e.preventDefault(); e.stopPropagation();
  }

  queryData() {
    if (!this.container[0].length) {
      if (!this.props.options.length) {
        // Fetch.jsonp('getCategoryTree', {
        //   isActive: this.props.isActive || 'y'
        // }).then((content) => {
        //   if (content.isSuccess) {
        //     const data = this.props.processData(content.retValue);
        //     this.editData(data);
        //     this.checkAll(data);
        //     this.container[0] = data;
        //     this.formatData(data, this.props.data.length);
        //     this.reflush();
        //     this.renderValue(data);
        //   }
        // });
      } else {
        const data = this.props.processData(this.props.options);
        this.editData(data);
        this.checkAll(data);
        this.container[0] = data;
        this.formatData(data, this.props.data.length);
        this.reflush();
        this.renderValue(data);
      }
    }
  }

  editData(data) {
    if (!data || !data.length) {
      return;
    }
    data.forEach((item) => {
      item.checked = this.props.data.contain(item.key);
      this.editData(item.childList);
    });
  }

  formatData(data, bool) {
    if (!data || !data.length) {
      return;
    }
    this.container[data[0].level - 1] = data;
    if (!bool) {
      this.formatData(data[0].childList, bool);
    } else {
      let i = 0;
      for (; i < data.length; i += 1) {
        if (data[i].checked || data[i].childChecked) {
          this.formatData(data[i].childList, bool);
          return;
        }
      }
      if (i === data.length) {
        this.formatData(data[0].childList, bool);
      }
    }
  }

  reflush() {
    this.setState({ reflush: this.state.reflush += 1 });
  }

  clearList(level) { // 后面的子集都清空
    for (let i = level; i < this.container.length; i += 1) {
      this.container[i] = [];
    }
  }

  onSelect(item, checked) {
    item.checked = checked;
    this.checkItem(item.childList, checked);
    this.clearList(item.level);
    this.formatData(item.childList);
    this.checkAll(this.container[0]);
    this.reflush();
  }

  onClickItem(item) {
    this.clearList(item.level);
    this.formatData(item.childList);
    this.reflush();
  }

  checkItem(data, checked) {
    if (!data || !data.length) {
      return;
    }
    data.forEach((item) => {
      item.checked = checked;
      this.checkItem(item.childList, checked);
    });
  }

  checkAll(data) { // 检查所有节点，判断全选还是半选
    if (!data || !data.length) {
      return;
    }
    data.forEach((item) => {
      if (!item.childList || !item.childList.length) {
        return;
      }
      this.checkAll(item.childList);
      const children = [];
      let showLine = false;
      item.childList = item.childList || [];
      item.childList.forEach((item) => {
        if (item.childChecked || item.checked) {
          showLine = true;
        }
        if (item.checked) {
          children.push(item);
        }
      });
      item.checked = children.length === item.childList.length;
      item.childChecked = showLine;
    });
  }

  delectItem(list) {
    list && list.forEach((item) => {
      item.checked = false;
      item.childChecked = false;
      this.delectItem(item.childList);
    });
  }

  renderList(level) {
    const { disabled } = this.props;
    return (
      <ul
        className="use-svg kuma-cascade-multi-content"
      // key={this.state.reflush}
      >
        {
          this.container[level].map((item, idx) => {
            const { value } = item;
            return (
              <li
                key={idx}
                className="kuma-cascade-multi-list-item"
                title={value}
                onClick={this.onClickItem.bind(this, item)}
              >
                <CheckBoxItem
                  className={'checkbox-item'}
                  checked={item.checked}
                  onChange={this.onSelect.bind(this, item)}
                  textClick={false}
                  showLine={item.checked ? false : item.childChecked}
                  text={value}
                  disabled={disabled}
                />
              </li>
            );
          })
        }
      </ul>
    );
  }

  renderCheckList(data) {
    if (!data || !data.length) {
      return;
    }
    return (
      <ul className="tree-node-ul">
        {
          data.map((item) => {
            const { value, childList, level, checked, childChecked, open } = item;
            if (!checked && !childChecked) {
              return null;
            }
            return (
              <li className="tree-node-ul-li tree-node-ul-li-open" title={value}>
                <div className="tree-node-ul-li-div" style={{ paddingLeft: (level * 15) + 'px' }}>
                  <i
                    className={!open ? 'kuma-icon kuma-icon-triangle-down' : 'kuma-icon kuma-icon-triangle-right'}
                    style={childList && childList.length ? {} : { visibility: 'hidden' }}
                    onClick={() => { item.open = !item.open; this.setState({ listIdx: this.state.listIdx += 1 }); }}
                  />
                  <span className="tree-node-ul-li-span">
                    <span className="tree-node-ul-li-span-label" style={{ maxWidth: '134px' }}>
                      {value}
                    </span>
                    <span
                      className="tree-node-ul-li-del"
                      onClick={() => {
                        item.checked = false;
                        item.childChecked = false;
                        this.delectItem(item.childList);
                        this.checkAll(this.container[0]);
                        this.setState({ listIdx: this.state.listIdx += 1 });
                      }}
                    >删除</span>
                  </span>
                </div>
                {
                  !open ? this.renderCheckList(childList) : null
                }
              </li>
            );
          })
        }
      </ul>);
  }

  renderValue(data) {
    if (!data || !data.length) {
      return;
    }
    data.forEach((item) => {
      if (!this.props.onlyLevel && item.checked) {
        this.checkedValue.push(item);
        this.checkedId.push(item.key);
        this.state.valueString += (item.value + ';');
      } else if (item.checked && item.level == this.props.onlyLevel) {
        this.checkedValue.push(item);
        this.checkedId.push(item.key);
        this.state.valueString += (item.value + ';');
      }
      this.renderValue(item.childList);
    });
    this.setState({ valueString: this.state.valueString });
  }

  submit() {
    this.setState({ arrow: 'kuma-cascader-arrow', show: false });
    this.state.valueString = '';
    this.checkedId = [];
    this.checkedValue = [];
    this.renderValue(this.container[0]);
    this.props.onSubmit && this.props.onSubmit(this.checkedId, this.checkedValue, this.container[0]);
    this.props.onChange && this.props.onChange(this.checkedId, this.checkedValue, this.container[0]);
  }

  render() {
    const { cascadeSize, placeholder, className } = this.props;
    const content = [];
    for (let i = 0; i < cascadeSize; i += 1) {
      content.push(this.renderList(i));
    }
    return (
      <div onClick={this.preventDefault} className={`pp-cascader-multi-wrapper ${className}`}>
        <div
          className="kuma-cascade-multi-input kuma-cascader-wrapper"
          onClick={() => {
            this.queryData();
            this.setState({ arrow: 'kuma-cascader-arrow kuma-cascader-arrow-reverse', show: true });
          }}
        >
          <div className="kuma-cascader-text" >
            <div className="kuma-cascader-trigger">
              <div style={{ width: '120px' }} title={this.state.valueString || ''}>
                {
                  this.state.valueString || <div className="kuma-cascader-placeholder">{placeholder}</div>
                }
              </div>
            </div>
          </div>
          <div className={this.state.arrow}>
            <i className="kuma-icon kuma-icon-triangle-down" />
          </div>
        </div>
        {
          this.state.show ?
            <div className="kuma-dropdown-placement-bottomLeft">
              <div className="kuma-cascade-multi-select-panel-content">
                <div className="kuma-cascade-multi-select-panel-wrap">
                  <div
                    className="kuma-cascade-multi"
                    style={{ minWidth: (149 * cascadeSize) + 227 + 'px' }}
                  >
                    {
                      content
                    }
                    <div className="kuma-cascade-multi-result">
                      <div className="kuma-cascade-multi-result-title">
                        <span>已选择</span>
                        <span
                          className="kuma-cascade-multi-result-clean"
                          onClick={() => {
                            this.delectItem(this.container[0]);
                            this.setState({ listIdx: this.state.listIdx += 1 });
                          }}
                        >清空</span>
                      </div>
                      <div className="kuma-cascade-multi-result-tree" key={this.state.listIdx}>
                        {
                          this.renderCheckList(this.container[0])
                        }
                      </div>
                    </div>
                  </div>
                  <div className="kuma-cascade-multi-select-footer" style={{ minWidth: (149 * cascadeSize) + 227 + 'px' }}>
                    <Button
                      onClick={this.submit.bind(this)}
                    >确定</Button>
                  </div>
                </div >
              </div >
            </div > : null
        }
      </div>
    );
  }
}

CascadeMultiSelect.propTypes = {
  processData: React.PropTypes.func,
  url: React.PropTypes.string,
  options: React.PropTypes.array,
  className: React.PropTypes.string,
  placeholder: React.PropTypes.string,
  cascadeSize: React.PropTypes.number,
  onlyLevel: React.PropTypes.number,
  data: React.PropTypes.array
};

CascadeMultiSelect.defaultProps = {
  processData: (val) => { return val; },
  url: '',
  options: [],
  className: '',
  placeholder: '请选择',
  cascadeSize: 3,
  onlyLevel: 0,
  data: []
};

export default CascadeMultiSelect;
