import React from 'react';

require('./style.less');

class CheckBoxItem extends React.Component {
  constructor(props) {
    super(props);
    this.state = {
      checkboxName: props.checked ? 'checkbox-style-checked' : ''
    };
    if (props.type === 'indeterminate') {
      this.state.checkboxName = 'checkbox-style-indeterminate';
    }
  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.type === 'indeterminate') {
      this.setState({ checkboxName: 'checkbox-style-indeterminate' });
    }
  }

  select() {
    if (this.props.disabled) { // 禁用
      return;
    }
    let { checkboxName } = this.state;
    if (checkboxName !== 'checkbox-style-checked') {
      checkboxName = 'checkbox-style-checked';
    } else {
      checkboxName = '';
    }
    this.setState({ checkboxName });
    this.props.onChange && this.props.onChange(checkboxName === 'checkbox-style-checked');
  }

  render() {
    const { className, text, style } = this.props;
    const { checkboxName } = this.state;
    return (
      <div
        className={`checkbox-style-wrap ${className}`}
        onClick={this.select.bind(this)}
        style={style || {}}
      >
        <div className={`checkbox-style-base ${checkboxName}`} /><span className="text-value">{text || ''}</span>
      </div>
    );
  }

}

export default CheckBoxItem;
