import React, { Component } from 'react';
import { addClass, isValue, isNumber, isTel, isEmail } from '../Utils';

class FileUpload extends Component {

  click() {
    this.file.click();
  }

  render() {
    const { className, style, text, type, accept } = this.props;
    const event = {};
    for (const ev in this.props) {
      if (ev.indexOf('on') !== -1) {
        event[ev] = this.props[ev];
      }
    }
    return (
      <span className={addClass('file-wrap')}>
        <div
          className={`${className} file-div`}
          style={style}
          onClick={this.click.bind(this)}
        >
          {text}
        </div>
        <input type="file"
          ref={c => this.file = c}
          {...event}
          accept={accept.join(',')}
          className="file-dom"
        />
      </span>
    )
  }
}

FileUpload.propTypes = {
  text: React.PropTypes.string,
  accept: React.PropTypes.array,
  className: React.PropTypes.string,
  style: React.PropTypes.object,
  onChange: React.PropTypes.func,
  onClick: React.PropTypes.func,
};
FileUpload.defaultProps = {
  text: '附件上传',
  className: '',
  accept: [],
  style: {},
  onChange: () => { },
  onClick: () => { },
};
export default FileUpload;