import React, { Component } from 'react';
import { addClass, isValue, isNumber, isTel, isEmail } from '../Utils';
import Button from '../Button';

class Info extends Component {
    cancel() {
        this.props.onCancel && this.props.onCancel();
    }
    submit() {
        this.props.onSubmit && this.props.onSubmit();
    }
    render() {
        const { className, width, height, title, okText, cancelText, onSubmit, onCancel, otherButton } = this.props;
        return (
            <div
                className={addClass('info-modal') + ' ' + className}
                style={{ width, height }}
            >
                {
                    title ? <div className="info-modal-title">
                        {title}
                    </div> : null
                }
                <div className="info-modal-content">
                    {this.props.children}
                </div>
                {
                    onSubmit || onCancel || (otherButton && otherButton.length) ?
                        <div className="info-modal-bottom">
                            {
                                onSubmit ?
                                    <Button type='submit' text={okText || '确定'} onClick={this.submit.bind(this)}/> : null
                            }
                            {
                                onSubmit ? <span style={{ padding: '15px' }} /> : null
                            }
                            {
                                onCancel ?
                                    <Button type='cancel' text={cancelText || '取消'} onClick={this.cancel.bind(this)} /> : null
                            }
                            {
                                otherButton && otherButton.map((item) => {
                                    <span>
                                        <span style={{ padding: '15px' }} />
                                        <Button type='cancel' text={item.text} onClick={item.onClick} />
                                    </span>
                                })
                            }
                        </div> : null
                }

            </div>
        )
    }
}
export default Info;