import React, { Component } from 'react';
import ReactDOM from 'react-dom';
import Info from './Info';

let div = document.getElementsByClassName('ying-background-shadow')[0];
if (!div) {
  div = document.createElement('div');
  div.className="ying-background-shadow";
  document.body.appendChild(div);
}


class Modal extends Component {
  componentDidMount() {
    div.style.display = this.props.show ? 'block' : 'none'
  }
  componentWillReceiveProps(nextProps) {
    div.style.display = nextProps.show ? 'block' : 'none'
  }
  hide() {
    div.style.display = 'none'
  }
  show() {
    div.style.display = 'block'
  }
  render() {
    this.props.hide = this.hide.bind(this);
    return (
      <div>
        { Modal.init(this.props)}
      </div>
    )
  }
}

Modal.propTypes = {
  className: React.PropTypes.string,
  width: React.PropTypes.string,
  height: React.PropTypes.string,
  title: React.PropTypes.string,
  okText: React.PropTypes.string,
  cancelText: React.PropTypes.string,
  onSubmit: React.PropTypes.func,
  onCancel: React.PropTypes.func,
  otherButton: React.PropTypes.array
};
Modal.defaultProps = {
  className: '',
  width: '600px',
  height: '60%',
  title: '',
  otherButton: [],
  //onCancel: () => {}
};

Modal.init = (props) => {
  ReactDOM.render(<Info  {...props} />, div);
};
export default Modal;