import React, { Component } from 'react';
import { addClass, isValue, isNumber, isTel, isEmail } from '../Utils';

class Pagination extends Component {
	constructor(props) {
		super(props);
		this.state = {
			current: props.current || 1
		}
	}

	prev() {
		if (this.state.current <= 1) {
			return;
		}
		this.setState({ current: this.state.current -= 1 });
		this.props.onChange && this.props.onChange(this.state.current);
	}

	next() {
		if (this.state.current >= this.props.total) {
			return;
		}
		this.setState({ current: this.state.current += 1 });
		this.props.onChange && this.props.onChange(this.state.current);
	}

	current(current) {
		this.setState({ current });
		this.props.onChange && this.props.onChange(current);
	}

	render() {
		const { className, style, total } = this.props;
		const { current } = this.state;
		const arr = [];
		let left = false;
		let right = false;
		if (total <= 7) {
			for (let i = 1; i <= total; i += 1) {
				arr.push(i);
			}
		} else {
			if (current - 3 <= 1) {
				left = true;
				arr.push(2);
				arr.push(3);
				arr.push(4);
				arr.push(5);
				arr.push(6);
			} else if (current + 3 >= total) {
				right = true;
				arr.push(total - 5);
				arr.push(total - 4);
				arr.push(total - 3);
				arr.push(total - 2);
				arr.push(total - 1);
			} else {
				arr.push(current - 2);
				arr.push(current - 1);
				arr.push(current);
				arr.push(current + 1);
				arr.push(current + 2);
			}
		}
		return (
			<span className={addClass('pagination-wrap')}>
				<ul className={`${className} pagination-div`} style={style}>
					<li
						className="prev"
						onClick={this.prev.bind(this)}
					>上一页</li>
					<li
						className={current === 1 ? 'page current' : 'page'}
						onClick={this.current.bind(this, 1)}
					>1</li>
					{
						left ? null : <li className="separate">...</li>
					}
					{
						arr.map((item) => {
							return (
								<li
									className={current === item ? 'page current' : 'page'}
									onClick={this.current.bind(this, item)}
								>{item}</li>
							);
						})
					}
					{
						right ? null : <li className="separate">...</li>
					}
					<li className={current === total ? 'page current' : 'page'}
						onClick={this.current.bind(this, total)}
					>{total}</li>
					<li
						className="next"
						onClick={this.next.bind(this)}
					>下一页</li>
				</ul>
			</span>
		)
	}
}

Pagination.propTypes = {
	total: React.PropTypes.number,
	className: React.PropTypes.string,
	style: React.PropTypes.object,
	onChange: React.PropTypes.func,
};
Pagination.defaultProps = {
	total: 20,
	current: 1,
	className: '',
	style: {},
	onChange: () => { },
};
export default Pagination;