import React from 'react';

require('../Checkbox/style.less');

class Radio extends React.Component {

  constructor(props) {
    super(props);
    this.state = {
      checkboxName: props.checked ? 'checkbox-style-checked' : ''
    };
  }

  componentWillReceiveProps(nextProps) {
    if (nextProps.checked) {
      this.setState({ checkboxName: 'checkbox-style-checked' });
    } else {
      this.setState({ checkboxName: '' });
    }
  }

  select() {
    if (this.props.disabled) {
      return;
    }
    this.props.onChange && this.props.onChange();
  }

  render() {
    const { className, text, style } = this.props;
    const { checkboxName } = this.state;
    return (
      <div
        className={`checkbox-style-wrap ${className}`}
        onClick={this.select.bind(this)}
        style={style || {}}
      >
        <div className={`radio-style-base ${checkboxName}`} /><span className="text-value">{text || ''}</span>
      </div>
    );
  }
}

export default Radio;
