import React, { Component } from 'react';
import { addClass, isValue, isNumber, isTel, isEmail } from '../Utils';

class Select extends Component {
  constructor(props) {
    super(props);
    this.state = {
      key: props.value,
      showRequired: false,
      fileName: props.placeholder,
      classPlace: 'please-fill',
      classRequire: 'infomation-hide',
      classlist: 'hide-list',
      classrect: 'rect-down'
    }
    this.options = props.options;
    // if (Object.keys(props.data).length) {
    //   this.state.classPlace = 'select-name';
    //   this.state.fileName = props.fileName || props.placeholder;
    //   this.state.key = Object.keys(props.data)[0];
    //   this.options[Object.keys(props.data)[0]] = props.data[Object.keys(props.data)[0]];
    // }
    this.required = false;
  }

  componentDidMount() {
    document.addEventListener('mousedown', this.blur.bind(this), false);
  }

  componentWillReceiveProps(nextProps) {
    this.options = nextProps.options;
    this.setState({
      key: nextProps.value
    })
  }

  focus() {
    this.setState({
      classPlace: 'select-name',
      classlist: 'show-list',
      fileName: this.props.fileName || this.props.placeholder,
      classrect: 'rect-up'
    });
    this.props.onFocus && this.props.onFocus();
  }

  blur() {
    if (!this.state.key) {
      this.required = false;
      this.setState({ classPlace: 'please-fill', classlist: 'hide-list', classRequire: 'infomation-hide', fileName: this.props.placeholder });
    }
    this.setState({ classlist: 'hide-list', classrect: 'rect-down' });
    this.props.onBlur && this.props.onBlur();
    this.select && this.select.blur();
  }

  click(key, e) {
    e.stopPropagation();
    e.preventDefault();
    e.nativeEvent.stopImmediatePropagation();
    this.setState({ key, classlist: 'hide-list', classrect: 'rect-down' });
    this.select && this.select.blur();
    this.props.onBlur && this.props.onBlur();
    this.props.onChange && this.props.onChange({ key, value: this.options[key] });
  }

  clear(e) {
    e.stopPropagation();
    e.preventDefault();
    e.nativeEvent.stopImmediatePropagation();
    this.setState({ key: '', classPlace: 'please-fill', classlist: 'hide-list', classrect: 'rect-down', fileName: this.props.placeholder });
    this.select && this.select.blur();
    this.props.onBlur && this.props.onBlur();
    this.props.onChange && this.props.onChange();
  }

  render() {
    const { className, style, placeholder, requireText, allowClear, showName } = this.props;

    const { key, classPlace, classRequire, fileName, classlist, classrect } = this.state;
    return (
      <div
        style={style}
        className={addClass('select-wrap') + ' ' + className}
        onMouseDown={(e) => { e.nativeEvent.stopImmediatePropagation(); e.stopPropagation(); e.preventDefault(); this.select && this.select.focus() }}
      >
        {showName ? <div className={`placeholder ${classPlace}`}>{fileName}</div> : null}
        <div className="show-value">{this.options[key] || key}</div>
        <ul className={`option-wrap clearfix ${classlist}`}>
          {
            Object.keys(this.options).map((key, idx) => {
              return (
                <li
                  className={`item ${key == this.state.key ? 'focus' : null}`}
                  key={idx}
                  onClick={this.click.bind(this, key)}
                >{this.options[key]}</li>
              );
            })
          }
        </ul>
        <select
          ref={c => this.select = c}
          style={{ position: 'absolute', opacity: 0, zIndex: '-10' }}
          onFocus={this.focus.bind(this)}
        ></select>
        {
          allowClear && key ? <div
            className="clear"
            onMouseDown={this.clear.bind(this)}
          >x</div> : <div className={`rect ${classrect}`}></div>
        }
      </div>
    )
  }
}

Select.propTypes = {
  className: React.PropTypes.string,
  options: React.PropTypes.object,
  value: React.PropTypes.string,
  require: React.PropTypes.bool,
  showName: React.PropTypes.bool,
  allowClear: React.PropTypes.bool,
  requireText: React.PropTypes.string,
  style: React.PropTypes.object,
  placeholder: React.PropTypes.string,
  fileName: React.PropTypes.string,
  onChange: React.PropTypes.func,
  onblur: React.PropTypes.func,
  onFocus: React.PropTypes.func,
  onClick: React.PropTypes.func,
};
Select.defaultProps = {
  options: { key: 'key' },
  value: '',
  fileName: '区域',
  className: '',
  style: {},
  require: false,
  showName: false,
  allowClear: false,
  requireText: '输入格式不正确',
  placeholder: '请选择',
  onChange: () => { },
  onblur: () => { },
  onFocus: () => { },
  onClick: () => { },
};
export default Select;